--- src/http/ngx_http_upstream_round_robin.c.orig	Mon Jan  4 05:14:43 2010
+++ src/http/ngx_http_upstream_round_robin.c	Mon Jan  4 05:14:50 2010
@@ -403,6 +403,16 @@
 
         /* there are several peers */
 
+        for (i = 0; i < rrp->peers->number; i++) {
+             if (!rrp->peers->peer[i].down) {
+                 break;
+             }
+        }
+
+        if (i == rrp->peers->number) {
+             goto failed;
+        }
+
         if (pc->tries == rrp->peers->number) {
 
             /* it's a first try - get a current peer */

